package codec

import (
	"bufio"
	"io"

	"code.google.com/p/snappy-go/snappy"
)

type snappyBufferedWriter struct {
	w io.Writer
}

func (sw *snappyBufferedWriter) Write(b []byte) (int, error) {
	log.Printf("snappyBuf: write(%d)", len(b))

	zdata, err := snappy.Encode(nil, b)
	if err != nil {
		return 0, err
	}

	return sw.w.Write(zdata)
}

type snappyBufferedReader struct {
	r io.Reader
}

func (sr *snappyBufferedReader) Read(b []byte) (int, error) {
	log.Printf("snappyBuf: read(%d)", len(b))


}
