$.widget('djrandom.songlist', {
    options: {
    },
    _create: function() {
        var box = this.element;
        box.addClass('songlist');
        box.append($('<ol/>').addClass('playlist').sortable().on('click', '.action-remove', function() {
            $(this).parent('li').remove();
        }));
        $('ol', box).disableSelection();
        this._refresh();
    },
    _refresh: function() {
        $.noop;
    },
    _destroy: function() {
        $.noop;
    },

    _setOptions: function() {
        this._superApply(arguments);
        this._refresh();
    },
    _setOption: function(key, value) {
        this._super(key, value);
    },

    addSong: function(song) {
        var songlist = $('ol.playlist', this.element);
        el = $('<li/>');
        el.text(song.meta.artist + " - " + song.meta.title);
        el.append($('<span/>').addClass('action-remove ui-icon inline-icon ui-icon-close'));
        el.append($('<span/>').addClass('action-suggest ui-icon inline-icon ui-icon-plus'));
        el.append($('<span/>').addClass('action-play ui-icon inline-icon ui-icon-play'));
        el.attr('songid', song.id);
        el.attr('dlurl', '/dl/' + song.audio_file.md5);
        el.data('song', song);
        el.addClass('ui-state-default');
        el.disableSelection();
        el.appendTo(songlist);
        return el;
    },

    getSongs: function() {
        return $('.playlist li', this.element).map(function() {
            return $(this).data('song');
        });
    },
    clearSongs: function() {
        $('ol.playlist li', this.element).remove();
    }
})
$.widget('djrandom.songbox', $.djrandom.songlist, {
    _create: function() {
        var box = this.element;
        box.addClass('songbox');
        box.append($('<a/>').addClass('btn action-clear').text('Clear').
                click(function() {
                    $('.playlist li', box).remove();
                }));
        var appendall = $('<a/>').addClass('btn action-appendall').text('Append all');
        box.append(appendall);
        appendall.click(function() {
            var slist = $(box).songbox('option', 'parentlist');
            if(slist !== null) {
                $(box).songbox('getSongs').each(function(i, song) {
                    slist.songlist('addSong', song);
                });
            }
        });
        box.append($('<a/>').addClass('btn action-nextall').text('Play all as next song'));
        this._super();
    },
    addSong: function(song) {
        added = this._super(song);
        el.draggable({
            helper: 'clone',
            appendTo: 'body'
        });
        $('.action-play', added).remove();
    }
})
