// Miscellaneous useful functions.

var delay = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  };
})();

djrandom.windowResize = function() {
  delay(function() {
    // Resize the playlist view.
    // var plv = $('#playlist_view');
    // plv.height($(window).height() - 16 - plv.offset().top);

    // Recenter the player.
    var ploff = $(window).height() / 2 - 100;
    $('#player').css('margin-top', '' + ploff + 'px');
  }, 100);
};

djrandom.generateFacetDropdownMenus = function() {
    var dst = $('#dFilterMenu');
    var out = '';
    var filters = [];
    var dfcount = 0;

    // Create the menu entries directly as HTML for the Bootstrap
    // drop-downs.
    function addFilter(filterData) {
        var result = dfcount;
        filters[dfcount] = filterData;
        dfcount++;
        return result;
    }
            
    function addElem(name, count, filterData) {
        return ('<li><a role="menuitem" href="#" data-filter="' 
                + addFilter(filterData) + '">' + name 
                + ' (' + count + ')</a></li>');
    }

    var f = djrandom.playlist.GetFacets();

    out += '<li><small>By artist:</small></li>';
    $.each(f.artists, function(artist, artistdata) {
        out += '<li class="dropdown-submenu">';
        out += '<a href="#" data-filter="' + addFilter({artist: artist}) + '">';
        out += artist + ' (' + artistdata.count + ')';
        out += '<ul class="dropdown-menu">';
        $.each(artistdata.albums, function(album, albumdata) {
            out += addElem(album, albumdata.count, {artist: artist, album: album});
        });
        out += '</ul></li>';
    });

    out += '<li class="divider"></li>';
    out += '<li><small>By genre:</small></li>';
    $.each(f.genres, function(genre, genredata) {
        out += addElem(genre, genredata.count, {genre: genre});
    });

    dst.html(out);

    dst.find('a').click(function() {
        var filterId = parseInt($(this).attr('data-filter'));
        var filterData = filters[filterId];
        console.log('resulting filter: ' + JSON.stringify(filterData));
        djrandom.playlist.ApplyFilter(filterData);
    });
};
