function SongHistory(api) {
    this.buffer = [];
    this.api = api;
    this.maxLen = 3;
}

SongHistory.prototype.push = function(songId) {
    //just add to buffer, without doing nothing to API
    this.buffer.push(songId);
    if(this.buffer.length > this.maxLen) {
        this.buffer.splice(0, 1);
    }
}

SongHistory.prototype.addToPlayLog = function(songId) {
    this.push(songId);
    this.api.AddToPlayLog(this.buffer);
}

SongHistory.prototype.clear = function() {
    this.buffer = [];
}

// Select audio files that are appropriate for this interface
// (specifically, mp3). This sets the 'song.audio_file' attribute
// for later access.
//
// TODO: improve the selection by sorting by bitrate.
function pickAudioFile(song) {
    for (var i = 0; i < song.files.length; i++) {
        var af = song.files[i];
        if (af.mime_type == "audio/mpeg") {
            song.audio_file = af;
            return af;
        }
    }
    return null;
}

djrandom.Suggestions = function(raw) {
    this.songs = [];
    for(var i=0; i < raw.results.length; i++) {
        var song = raw.results[i];
        if(pickAudioFile(song)) {
            song.origin = raw.song_origin[i];
            this.songs.push(song);
        }
    }
}

djrandom.Suggestions.prototype.onlyMarkov = function(raw) {
    //this is *not* just a filter on the songs with markovian origin
    //this will limit to the first songs which all have markovian origin
    var i;
    var ret = [];
    for(i=0; i < this.songs.length; i++) {
        if(this.songs[i].origin.startsWith('markov/')) {
            ret.push(this.songs[i]);
        }
        else {
            break;
        }
    }
    return ret;
}
