$.fn.isChildOf = function(el) {
    return $(el).has(this).length > 0;
};

function now_playing() {
    return $('#playing li.nowplaying');
}
function next_in_playlist() {
    var next = now_playing().next('li');
    if(next.size() === 0) {
        return null;
    }
    return next;
}

function play_element(songel) {
        songel.parent('.playlist').find('li').removeClass('nowplaying ui-state-highlight');
        songel.addClass('nowplaying ui-state-highlight');
        var song = songel.data('song');
        djrandom.player.Play(song);
}

function suggest_in_box(songids) {
    $('#suggestionsBox').songbox('clearSongs');
    djrandom.api.Suggest(songids, 10, function(suggestions) {
        $('#suggestionsBox').effect('highlight');
        suggestions.onlyMarkov().map(function(song) {
            $('#suggestionsBox').songbox('addSong', song);
        });
    }, console.error);
}
jQuery(function($) {
    djrandom.api = new djrandom.API('/');
    djrandom.player = new djrandom.Player();
    djrandom.songhistory = new SongHistory(djrandom.api);

    // Set up autocompletion on the search box.
    $('#searchField').focus();
    $('#searchField').typeahead({
        source: djrandom.api.Autocomplete,
        items: 12,
        minLength: 2
    });

    $('#searchButton').click(function(evt, el) {
        $('#resultsBox').songbox('clearSongs');
        djrandom.api.Search($('#searchField').val(), function(songs) {
        $('#resultsBox').effect('highlight');
            songs.map(function(song) {
                $('#resultsBox').songbox('addSong', song);
            });
        }, console.error);
    });
    $('#playing').songlist();
    $('#playing .playlist').addClass('songdroppable').droppable({
        'accept': 'li',
        'activeClass': 'ui-state-default',
        'hoverClass': 'ui-state-hover',
        'accept': ':not(.sorted)',
        'drop': function(ev, ui) {
            if($(ui.draggable).isChildOf('#playing')) {
                return;
            }
            var song = $(ui.draggable).data('song');
            $('#playing').songlist('addSong', song);
        }}).sortable({
        items: 'li',
        sort: function() {
            $(this).addClass('sorted');
        }
    });
    $('#resultsBox').songbox({parentlist: $('#playing')});
    $('#suggestionsBox').songbox({parentlist: $('#playing')});
    $('.songlist .playlist').on('click', '.action-suggest', function() {
        songel = $(this).parent('li');
        suggest_in_box([songel.data('song').id]);
    });
    $('.songlist').on('click', '.action-suggest-multiple', function() {
        var songids = _.pluck(
                $(this).parent(':djrandom-songlist').songlist('getSongs'),
                'id');
        suggest_in_box(songids);
    });
    

    $('.songlist').on('click', '.action-play', function(evt) {
        play_element($(this).parent('li'));
    });
    djrandom.player.on('next', function() {
        djrandom.songhistory.addToPlayLog(now_playing().attr('songid'));
        var next = next_in_playlist();
        if(next !== null) {
            play_element(next);
        }
    });
})
